server/vessel/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home');
Route::get('/home', 'HomeController@index')->name('home');

/** Authentication Routes **/
Auth::routes();

/** User Routes **/
Route::get('/user/profile/{id}', 'UserProfileController@show')->name('user.profile')->middleware('auth');
Route::post('/user/profile/{id}/update', 'UserProfileController@update')->name('user.profile.update')->middleware('auth');
Route::resource('user', 'UserController')->middleware('auth');

/** File Routes **/
Route::resource('file', 'FileController')->middleware('auth', 'authorizeRole:admin');

/** File Ignore Type Routes **/
Route::resource('file_ignore_type', 'FileIgnoreTypeController')->middleware('auth', 'authorizeRole:admin');
Route::post('/file_ignore_type/delete', 'FileIgnoreTypeController@destroyMultiple')->name('file_ignore_type.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** File Ignore Dir Routes **/
Route::resource('file_ignore_dir', 'FileIgnoreDirController')->middleware('auth', 'authorizeRole:admin');
Route::post('/file_ignore_dir/delete', 'FileIgnoreDirController@destroyMultiple')->name('file_ignore_dir.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Storage Provider Routes **/
Route::resource('storage', 'StorageController')->middleware('auth', 'authorizeRole:admin');
Route::post('/storage/delete', 'StorageController@destroyMultiple')->name('storage.provider.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** AppClient Routes **/
Route::resource('client', 'AppClientController')->middleware('auth', 'authorizeRole:admin');
Route::post('/client/delete', 'AppClientController@destroyMultiple')->name('client.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Setting Routes **/
Route::resource('setting', 'SettingController')->middleware('auth', 'authorizeRole:admin');
Route::post('/setting/all', 'SettingController@updateAll')->name('setting.updateAll')->middleware('auth', 'authorizeRole:admin');

/** User Setting Routes **/
Route::resource('user_setting', 'UserSettingController')->middleware('auth', 'authorizeRole:admin');
Route::post('/user_setting/delete', 'UserSettingController@destroyMultiple')->name('user_setting.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** User Role Routes **/
Route::resource('user_role', 'UserRoleController')->middleware('auth', 'authorizeRole:admin');
Route::post('/user_role/delete', 'UserRoleController@destroyMultiple')->name('user_role.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Deployment Routes **/
Route::resource('deployment', 'DeploymentController')->middleware('auth', 'authorizeRole:admin');
Route::post('/deployment/delete', 'DeploymentController@destroyMultiple')->name('deployment.destroyMultiple')->middleware('auth', 'authorizeRole:admin');

/** Search Routes **/
Route::get('/search/{str}', 'SearchController@search');
Route::post('/search/logs', 'SearchController@searchLog');

/** Monitoring Routes **/
Route::resource('log', 'AppLogController')->middleware('auth', 'authorizeRole:admin');

/** Download Routes **/
Route::get('/download/{id}', 'DownloadController@downloadFile')->middleware('auth');

/** LDAP Routes **/
Route::resource('ldap', 'LdapController')->middleware('auth', 'authorizeRole:admin');
Route::get('/ldap/{id}/import', 'LdapController@import')->name('ldap.import')->middleware('auth', 'authorizeRole:admin');

server/vessel/app/File.php
<?php

namespace App;

use Laravel\Scout\Searchable;
use Illuminate\Database\Eloquent\Model;
use Spatie\BinaryUuid\HasBinaryUuid;

class File extends Model
{
		use HasBinaryUuid;
		use Searchable;

		public function user()
		{
			return $this->belongsTo('App\User', 'user_id', 'user_id');
		}

		public function uploads()
    {
        return $this->hasMany('App\FileUpload', 'file_id', 'file_id');
    }

		public function storageProvider() {
			return $this->hasOne('App\StorageProvider', 'provider_id', 'provider_id');
		}

		public function filePath() {
			return $this->hasOne('App\FilePath', 'path_id', 'file_path_id');
		}

		public function client() {
			return $this->hasOne('App\AppClient', 'client_id', 'client_id');
		}

		protected $fillable = [
			'file_id', 'file_name', 'file_path_id', 'file_type', 'file_size', 'hash', 'uploaded', 'encrypted', 'compressed', 'last_backup'
		];

		public function getKeyName() {
			return 'file_id';
		}

		public function getKey() {
			return $this->file_id_text;
		}

		public function getHashAttribute($value) {
			return bin2hex($value);
		}

		function toSearchableArray() {
			return [
				'file_id' => $this->file_id_text,
				'file_name' => $this->file_name,
				'file_type' => $this->file_type
			];
		}

		public $primaryKey = 'file_id';
		public $incrementing = false;
		protected $table = 'file';
		protected $uuids = ['user_id','file_path_id','provider_id','client_id'];
		protected $dates = ['created_at','updated_at','last_backup'];

}

server/vessel/app/Http/Controllers/FileController.php
<?php

namespace App;
namespace App\Http\Controllers;

use App\File;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use Laravel\Scout\Searchable;

class FileController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
			$files = File::paginate(25);  //DB::table('users')->paginate(1);

			return view('file.list', ['files' => $files]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
				$file = File::withUuid($id)->first();

				return view('file.show', ['file' => $file]);

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

server/vessel/app/Http/Controllers/api/FileController.php
<?php

namespace App\Http\Controllers\api;

use App;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class FileController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $file = App\File::withUuid($id)->firstOrFail();

				$file->save();

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

server/vessel/resources/views/file/ignore_dirs/create.blade.php
@extends('layouts.app')

@section('scripts')
	<script>
		$(document).ready( function() {

			$('.ui.form')
			  .form({
			    fields: {
			      directory: {
			        identifier: 'directory',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please enter a directory'
			          }
			        ]
			      }
			    }
			  });

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade')
					;
				})
			;
		});
	</script>
@endsection

@section('content')

<div class="ui very padded container">

	<h2 class="ui header">
		Add New Ignore Directory
		<div class="sub header"></div>
	</h2>

	@if( isset($error) )
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
	@endif

	<form method="POST" action="{{ route('file_ignore_dir.store') }}" class="ui form segment">
		@csrf
		<div class="ui centered stackable grid container">

		  <div class="twelve wide column field">
		    <label>Directory</label>
				<input type="text" id="directory" name="directory" placeholder="Enter Directory" required>
		  </div>

			<div class="row">
				<div class="eight wide centered column">
					<div class="ui error message"></div>
				</div>
			</div>
			<div class="row">
				<div class="two wide centered column">
				  <div class="ui primary submit button">{{ __('Add') }}</div>
				</div>
			</div>

		</div>
	</form>

</div>
@endsection

server/vessel/resources/views/file/ignore_dirs/list.blade.php
@extends('layouts.app')

@section ('scripts')
	<script src="{{ asset('js/tablesort.min.js') }}"></script>
	<script>
		$(document).ready( function() {

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade');
				});

			$('.menu .item').tab();

			var list_form = $('#list_form');

			$('table').tablesort();

			$('#delete_selected').click(function() {
				$('input[name="_method"]').val('POST');
				list_form.attr('action', '{{ route('file_ignore_dir.destroyMultiple') }}');
				list_form.submit();
			});

			$('#add_ignore_dir').click(function(e) {
				e.preventDefault();
				window.location.href= '{{ route('file_ignore_dir.create') }}';
			});

		});
	</script>
@endsection

@section('content')

	<div class="ui very padded container">

		@if(isset($success))
		<div class="ui positive message">
			<i class="close icon"></i>
			<div class="header">
				{{ $success }}
			</div>
		</div>
		@endif

		@if(isset($error))
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
		@endif

		<h2 class="ui header">
			Ignored Directories
			<div class="sub header">View and Manage Ignored File Directories</div>
		</h2>
	</div>

	<form id="list_form" action="" method="POST">
		@csrf
		<input type="hidden" name="_method" value="post" />

		<div class="ui very padded container">
			<table class="ui selectable sortable stackable padded striped table">
				<thead>
					<tr>
						<th class="no-sort" colspan="8">
			      	{{ $ignoreDirs->links() }}
			    	</th>
				  </tr>
					<tr>
						<th class="no-sort"></th>
						<th>Directory</th>
					</tr>
				</thead>
				<tbody>
					@foreach ($ignoreDirs as $dir)
						<tr>
							<td>
								<div class="ui fitted checkbox">
				          <input name="selectedIds[]" type="checkbox" value="{{ $dir->id }}"><label></label>
				        </div>
							</td>
							<td><a href="{{ route('file_ignore_dir.show', $dir->id) }}">{{ $dir->directory }}</td>
						</tr>
					@endforeach
				</tbody>
				<tfoot>
			    <tr>
						<th colspan="8">
							<div class="ui">
								<button id="add_ignore_dir" class="ui primary button">
									<i class="icon plus"></i>
								  Add
								</button>
								<button id="delete_selected" class="red ui button">
									<i class="icon delete"></i>
								  Delete
								</button>
							</div>
				      {{ $ignoreDirs->links() }}
			    	</th>
				  </tr>
				</tfoot>
			</table>
		</div>

	</form>

@endsection

server/vessel/resources/views/file/ignore_dirs/show.blade.php
@extends('layouts.app')

@section('scripts')
	<script>
		$(document).ready( function() {

			$('.ui.form')
			  .form({
			    fields: {
			      directory: {
			        identifier: 'directory',
			        rules: [
			          {
			            type   : 'empty',
			            prompt : 'Please enter a directory'
			          }
			        ]
			      }
			    }
			  });

			$('.message .close')
				.on('click', function() {
					$(this)
						.closest('.message')
						.transition('fade')
					;
				})
			;
		});
	</script>
@endsection

@section('content')

<div class="ui very padded container">

	<h2 class="ui header">
		Manage Ignore Directory
		<div class="sub header"></div>
	</h2>

	@if( isset($error) )
		<div class="ui negative message">
			<i class="close icon"></i>
			<div class="header">
				{{ $error }}
			</div>
		</div>
	@endif

	<form method="POST" action="{{ route('file_ignore_dir.update', $ignoreDir->id) }}" class="ui form segment">
		@csrf
		<input type="hidden" name="_method" value="PUT" />

		<div class="ui centered stackable grid container">

		  <div class="twelve wide column field">
		    <label>Directory</label>
				<input type="text" id="directory" name="directory" placeholder="Enter Directory" value="{{ $ignoreDir->directory }}" required>
		  </div>

			<div class="row">
				<div class="eight wide centered column">
					<div class="ui error message"></div>
				</div>
			</div>
			<div class="row">
				<div class="two wide centered column">
				  <div class="ui primary submit button">{{ __('Update') }}</div>
				</div>
			</div>

		</div>
	</form>

</div>
@endsection